# Modding Utilities
-------------------

This mod provides several utilities that were developed over time for specific mods that may be useful to the modding community at large.

#### v3.7
---------

- Patched an issue with reversible effect.

#### v3.6
---------

- Converted a patch to `FireBurst` to a transpiler to make the patch friendlier for other mods.
- Moved component fetching to `Awake`
- Added `HealthHandlerModifier` and moved regeneration into it.
- Moved Number of Jumps to `CharacterDataModifier` so that it would be applied properly.
- Added a check to prevent player max health from going into the negatives when removing a modifier.
- Deprecated several misleading temporary modifiers that had no effect.
- Deprecation of the `characterStatModifiers` field in `ReversibleEffect` along with the addition of a `stats` field to replace it, to help reduce confusion between it and the temporary modifier fields.
- `ReversibleEffect`s in child objects on the player are also removed upon `FullReset`, instead of only objects directly on the player.

#### v3.5
---------

- Added more efficient draw patch from DeckCustomization

#### v3.0
---------

- Added interface for game mode hooks on monos (Willuwontu)
- Added support for reversible effects on child gameobjects of the player

#### v2.8
---------

Added utilities for the out of bounds, agnostic of map embiggener

#### v2.7
---------

Minor `ReversibleEffect` bugfix

#### v2.6
---------

Bugfixes regarding multiple local players per client in online lobbies

#### v2.5
---------

Various bugfixes to stay compatible with RWF and UnboundLib

#### v2.4
---------

Various bugfixes regarding RWF 2v2 mode

#### v2.0
---------

Added `AIMinionHandler`.

#### v1.0
---------

BossSloth helped migrate lots of stuff from PCE for custom card effects

## More Efficient Draws
-----------------------

This mod automatically uses a _significantly_ more efficient algorithm for drawing cards from the deck. This is practically necessary since it can be possible for a significant fraction of the deck to be invalid (rarities set to 0, incompatible with players' current cards, etc.). This algorithm has been tested and verified to produce identical draws to the vanilla game's algorithm.
